"use strict";

exports.__esModule = true;
exports.default = void 0;

var React = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("react"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const __reactCreateElement__ = React.createElement;

/**
 * A factory function for creating asynchronous React components
 *
 * @param componentGetter A function that returns a React component or a promise that resolves a React component
 * @param options Optionally adds `loading` and `error` state components
 */
function createAsyncComponent(componentGetter, options = {}) {
  const {
    loading,
    error
  } = options;
  let cachedComponent;
  const PROD = typeof process !== 'undefined' && process.env.NODE_ENV === 'production';

  function _ref() {
    return cachedComponent;
  }

  function _ref4(component) {
    return cachedComponent = component;
  }

  return Object.assign(function AsyncComponent(props) {
    const [Component, setComponent] = React.useState(cachedComponent ? _ref : componentGetter);
    const [exception, setException] = React.useState(null);

    function _ref2(component) {
      if (PROD) cachedComponent = component;
      setComponent(() => component);
    }

    function _ref3(err) {
      return setException(err);
    }

    React.useEffect(() => {
      if ('then' in Component) Component.then(_ref2).catch(_ref3); // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
    return exception ? (error === null || error === void 0 ? void 0 : error(exception, props)) || null : 'then' in Component ? (loading === null || loading === void 0 ? void 0 : loading(props)) || null : __reactCreateElement__(Component, props);
  }, {
    load: () => {
      if (PROD) return cachedComponent ? Promise.resolve(cachedComponent) : Promise.resolve(componentGetter()).then(_ref4);
      return Promise.resolve(componentGetter());
    }
  });
}

var _default = createAsyncComponent;
exports.default = _default;