(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('react')) :
  typeof define === 'function' && define.amd ? define(['react'], factory) :
  (global = global || self, global.createAsyncComponent = factory(global.React));
}(this, (function (React) { 'use strict';

  function _extends() {
    _extends = Object.assign || function (target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];

        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }

      return target;
    };

    return _extends.apply(this, arguments);
  }

  /**
   * A factory function for creating asynchronous React components
   *
   * @param componentGetter A function that returns a React component or a promise that resolves a React component
   * @param options Optionally adds `loading` and `error` state components
   */

  var __reactCreateElement__ = React.createElement;

  function createAsyncComponent(componentGetter, options) {
    if (options === void 0) {
      options = {};
    }

    var _options = options,
        loading = _options.loading,
        error = _options.error;
    var cachedComponent;
    var PROD = typeof process !== 'undefined' && "production" === 'production';

    function _ref() {
      return cachedComponent;
    }

    function _ref4(component) {
      return cachedComponent = component;
    }

    return _extends(function AsyncComponent(props) {
      var _React$useState = React.useState(cachedComponent ? _ref : componentGetter),
          Component = _React$useState[0],
          setComponent = _React$useState[1];

      var _React$useState2 = React.useState(null),
          exception = _React$useState2[0],
          setException = _React$useState2[1];

      function _ref2(component) {
        if (PROD) cachedComponent = component;
        setComponent(function () {
          return component;
        });
      }

      function _ref3(err) {
        return setException(err);
      }

      React.useEffect(function () {
        if ('then' in Component) Component.then(_ref2).catch(_ref3); // eslint-disable-next-line react-hooks/exhaustive-deps
      }, []);
      return exception ? (error === null || error === void 0 ? void 0 : error(exception, props)) || null : 'then' in Component ? (loading === null || loading === void 0 ? void 0 : loading(props)) || null : __reactCreateElement__(Component, props);
    }, {
      load: function load() {
        if (PROD) return cachedComponent ? Promise.resolve(cachedComponent) : Promise.resolve(componentGetter()).then(_ref4);
        return Promise.resolve(componentGetter());
      }
    });
  }

  return createAsyncComponent;

})));
//# sourceMappingURL=create-async-component.dev.js.map
